/*
 * File         : Jacobi_h.java
 * Author       : Qiang Zheng
 * Created      : Tue Oct 20 10:23:30 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date:  $
 * Copyright	: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

/* Change from Array2??F to Array2**I */
/* This version is reserved because it suddenly cannot run , this version
is based on Jacobi_h.bak2*/
// package hpjdemo;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import hpjava.spmd.*;
import hpjava.spmd.adlib.*;
import hpjava.lang.*;

// public class Jacobi_h extends Frame implements ActionListener , ItemListener { 
public class Jacobi_h extends Frame implements ActionListener{ 
  static int n=16;
  static int rnflg = 1;
  static int numProc = 2;
  static int iterNum = 20;
  // static int Clrbase = 1;
  // static float Jcolor[][] = new Float[n][n];
  static SpmdEnv spmd;
  static Procs2 p;

  // static Choice procNum ;
  // static Choice numIter;
  // static Array1cI wait; 

  static JacoGraph jGraphics = new JacoGraph();
  static Array2ccI ColorArray_R;

  public void setNumIter(int n)
  {
	iterNum = n;
  }

  public void setNumProc(int n)
  {
	numProc = n;
  }

  public void init() {
    setFont(new Font("Helvetica", Font.PLAIN, 14));

    Panel pb = new Panel();

    // minputs = new MetroInputs(this);

    pb.setLayout(new GridLayout(10, 1));
    pb.setBackground(Color.orange);

    /* Button Brst = new Button("Restart");
     * Brst.addActionListener(this);
       pb.add(Brst); */

	/* Label label0 = new Label("Proc. Number: ");
	pb.add("CENTER",label0);
	procNum = new Choice();
    procNum.add("1");
    procNum.add("2");
    procNum.add("3");
    procNum.add("4");
    procNum.addItemListener(this);
    procNum.select("2");
	pb.add(procNum); 

	Label label1 = new Label("Iteration Times");
	pb.add("CENTER",label1);
	numIter = new Choice();
	numIter.add("10");
	numIter.add("20");
	numIter.add("30");
	numIter.add("40");
    numIter.addItemListener(this);
	numIter.select("20");
	pb.add(numIter); */

    Button Brun = new Button("Continue");
    Brun.addActionListener(this);
    pb.add(Brun);

    Button Bstop = new Button("Pause");
    Bstop.addActionListener(this);
    pb.add(Bstop);

    Button Bsmall = new Button("Zoom <<");
    Bsmall.addActionListener(this);
    pb.add(Bsmall);

    Button Blarge = new Button("Zoom >>");
    Blarge.addActionListener(this);
    pb.add(Blarge);

    // Button Bblank = new Button("Blank");
    // pb.add(Bblank);

    Button Bquit = new Button("Quit");
    Bquit.addActionListener(this);
    pb.add(Bquit);

    setLayout(new BorderLayout());
    // jGraphics = new JacoGraph();
		jGraphics.init();
    add("Center",jGraphics);
    // add("North",minputs);
    add("West",pb);
  }

  public void actionPerformed(ActionEvent evt) {
		/* if(evt.getActionCommand() == "Restart") {
		  rnflg = 5;
		} else */ if(evt.getActionCommand() == "Continue"){
    	  rnflg = 1;
		  // if(p.id() == 0) wait.dat()[wait.pos(0)] = 0;
		// System.out.println("wait is changed now");
    	} else if(evt.getActionCommand() == "Pause") {
		  rnflg = 0;
		} else if(evt.getActionCommand() == "Quit") {
		  rnflg = 2;
    	  // spmd.finalize();
		  // System.exit(0);
		} else if(evt.getActionCommand() == "Zoom <<") {
		  rnflg = 3;
		} else if(evt.getActionCommand() == "Zoom >>") {
		  rnflg = 4;
		} // else if(evt.getActionCommand() == "") {
		  //JacoGraph.setGridSize(4 * (ch.getSelectedIndex() + 1)
          //  ,4 * (ch.getSelectedIndex() + 1));
		  //}
  }

  void update() {
    jGraphics.repaint();
  }

  public static void main(String argv[]) {
    spmd = new SpmdEnv(argv);
    p=new Procs2(numProc,1);

	// wait = new Array1cI(p,1);
	// wait.dat()[wait.pos(0)] = 0;

	  if(p.id() == 0) {
	  	Jacobi_h jtest = new Jacobi_h();
    	jtest.init();
    	jtest.setSize(900, 700);
    	jtest.setLocation(20,30);
    	jtest.show();
	  } 

 	  if (p.on()) {
loop0:	 while (true) {
		/* if(wait.dat()[wait.pos(0)] == 1){
			continue loop0;
		} */
      int [] w = {1,1};

      BlockRange x = new BlockRange (n, p.dim(0), 3, 1, 1);
      BlockRange y = new BlockRange (n, p.dim(1), 3, 1, 1);
      Array2ddI u = new Array2ddI(spmd.apg,x,y);
      Index i = new Index (x);
      Index j = new Index (y);

	  Array2ccI ColorArray_R = new Array2ccI(spmd.apg,n,n);
	  // public Array2ccF ColorArray_G = new Array2ccF(spmd.apg,n,n);
	  // public Array2ccF ColorArray_B = new Array2ccF(spmd.apg,n,n);

      i.dim().over();
      for (i.begin(); i.test(); i.next()) {
          j.dim().over();
          for (j.begin(); j.test(); j.next()) {
            if (x.idx(i)==0 || x.idx(i)==n-1
                  || y.idx(j)==0 || y.idx(j)==n-1)
                u.dat()[u.pos(i, j)]=255;
            else
                u.dat()[u.pos(i, j)]=0;
          } j.dim().revo();
      } i.dim().revo();

      Array2ddI uold = new Array2ddI(spmd.apg,x, y) ;
      Index ic = new Index (x.subrng(n-2, 1));
      Index jc = new Index (y.subrng(n-2, 1));
      Adlib.remap(ColorArray_R,u);
      Adlib.copy(uold, u);
loop1: for (int l = 0; l < iterNum; l++) {
			if(rnflg == 0) { 
				continue loop1;
			} else if(rnflg == 2) {
				break loop0;
			} else if(rnflg == 3) {
				rnflg = 1;
				jGraphics.setRectSize(jGraphics.currentRectSize() / 2);
				jGraphics.repaint();
			} else if(rnflg == 4) {
				rnflg = 1;
				jGraphics.setRectSize(jGraphics.currentRectSize() * 2);
				jGraphics.repaint();
			} else if(rnflg == 1){
            Adlib.copy(uold, u);
            Adlib.writeHalo(uold,w,w);
            ic.dim().over();
            for (ic.begin(); ic.test(); ic.next()) {
                jc.dim().over();
                for (jc.begin(); jc.test(); jc.next()) {
                    u.dat()[u.pos(ic,jc)]
                        =  (uold.dat()[uold.pos(ic.shift(-1),jc)]+
                            uold.dat()[uold.pos(ic.shift(1),jc)] +
                            uold.dat()[uold.pos(ic,jc.shift(-1))]+
                            uold.dat()[uold.pos(ic,jc.shift(1))] + 4)/4 - 1;
                } jc.dim().revo();
            } ic.dim().revo();
            //Adlib.aprintf("%7.3f%"+n+"N", u);
            Adlib.remap(ColorArray_R,u);
	  		if(p.id() == 0) {
				jGraphics.setClr(ColorArray_R.dat());
            	jGraphics.repaint();
				// System.out.println("Iteration: " + l);
				// System.out.flush();
			}
			}
      } //end of for loop
      // Adlib.aprintf("%7.3f%"+n+"N", u);
	// wait.dat()[wait.pos(0)] = 1;
	} //end of while true
    } p.no();

    spmd.finalize();
	System.exit(0);
  }

  public void draw()
  {
	jGraphics.repaint();
  }

  /* public void itemStateChanged(ItemEvent e)
  {
	  if(e.getStateChange() == ItemEvent.SELECTED){
			if(e.getSource() == procNum) {
				setNumProc(Integer.valueOf(procNum.getSelectedItem()).intValue());
      			// System.out.println( procNum.getSelectedItem() + "\n" );
			} else if(e.getSource() == numIter){
				setNumProc(Integer.valueOf(numIter.getSelectedItem()).intValue());
      			// System.out.println(numIter.getSelectedItem() + "\n" );
			}
		update();
	  }
  } */
}

/* class setIterHandler implements ItemListener {
    private Choice iter_ch;

    public setIterHandler(Choice c) {iter_ch = c;}
    public void itemStateChanged(ItemEvent e)
    {
		Jacobi_h.setNumIter((iter_ch.getSelectedIndex()+1) * 10);
		System.out.println( iter_ch.getSelectedIndex() + "\n" );
    }
}

 class setProcHandler implements ItemListener {
    private Choice proc_ch;

    public setProcHandler(Choice c) {proc_ch = c;}
    public void itemStateChanged(ItemEvent e)
    {
		Jacobi_h.setNumProc(proc_ch.getSelectedIndex() + 1);
		System.out.println( proc_ch.getSelectedIndex() + "\n" );
    }
} */
